=== debian/changelog ===
rhonabwy (0.9.12-2build1) groovy; urgency=medium

  * No change rebuild against new GnuTLS 3.6.14 A192GCM support ABI.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 28 Sep 2020 14:47:14 +0100

rhonabwy (0.9.12-2) unstable; urgency=medium

  * d/patches: Disable test_rhonabwy_generate_key_pair, takes too much time
    in some environments

 -- Nicolas Mora <babelouest@debian.org>  Mon, 13 Jul 2020 12:00:37 -0400

rhonabwy (0.9.12-1) unstable; urgency=medium

  * New upstream release
  * d/uwsc.1: Remove uwsc manpage, use upstream manpage instead

 -- Nicolas Mora <babelouest@debian.org>  Mon, 13 Jul 2020 07:31:35 -0400

rhonabwy (0.9.11-3) unstable; urgency=medium

  * d/rules: avoid downloading dependencies if not found
  * rename rnbyc manpage to rnbyc.1

 -- Nicolas Mora <nicolas@babelouest.org>  Thu, 02 Jul 2020 20:56:30 -0400

rhonabwy (0.9.11-2) unstable; urgency=medium

  * Upload to unstable
  * Set upstream metadata fields
  * d/patches/test_timeout.patch: increase core timeout because it fails
    on some architectures

 -- Nicolas Mora <nicolas@babelouest.org>  Sun, 28 Jun 2020 12:42:51 -0400

rhonabwy (0.9.11-1) experimental; urgency=medium

  * New upstream release
  * d/control: Add rnbyc

 -- Nicolas Mora <nicolas@babelouest.org>  Tue, 23 Jun 2020 15:42:34 -0400

rhonabwy (0.9.10-1) experimental; urgency=medium

  * New upstream version

 -- Nicolas Mora <nicolas@babelouest.org>  Thu, 04 Jun 2020 12:14:12 -0400

rhonabwy (0.9.9-1) experimental; urgency=medium

  * Initial release (Closes: #961720)

 -- Nicolas Mora <nicolas@babelouest.org>  Mon, 25 May 2020 21:18:21 -0400
