=== debian/control ===
Source: rhonabwy
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian IoT Maintainers <debian-iot-maintainers@lists.alioth.debian.org>
Uploaders: Nicolas Mora <babelouest@debian.org>
Build-Depends: debhelper-compat (= 13)
             , dh-exec
             , liborcania-dev
             , libyder-dev
             , libulfius-dev
             , libgnutls28-dev
             , zlib1g-dev
             , cmake
             , pkg-config
             , check
             , doxygen
Standards-Version: 4.5.0
Homepage: https://github.com/babelouest/rhonabwy
Vcs-Browser: https://salsa.debian.org/debian-iot-team/oauth2/rhonabwy
Vcs-Git: https://salsa.debian.org/debian-iot-team/oauth2/rhonabwy.git
Rules-Requires-Root: no

Package: librhonabwy0.9
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: JWK, JWKS, JWS, JWE and JWT library
 Rhonabwy - JWK, JWKS, JWS, JWE and JWT library
 .
  - Create, modify, parse, import or export JSON Web Keys (JWK) and JSON Web
    Keys Set (JWKS)
  - Create, modify, parse, validate or serialize JSON Web Signatures (JWS)
  - Create, modify, parse, validate or serialize JSON Web Encryption (JWE)
    limited and experimental!
  - Create, modify, parse, validate or serialize JSON Web Token (JWT)
 .
 JWT Relies on JWS and JWE functions, so it supports the same functionnalities
 as the other 2. JWT functionnalities also support nesting serilization
 (JWE nested in a JWS or the opposite).

Package: librhonabwy-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: librhonabwy0.9 (= ${binary:Version}), ${misc:Depends}
Description: JWK, JWKS, JWS, JWE and JWT library - development
 Rhonabwy - JWK, JWKS, JWS, JWE and JWT library
 .
  - Create, modify, parse, import or export JSON Web Keys (JWK) and JSON Web
    Keys Set (JWKS)
  - Create, modify, parse, validate or serialize JSON Web Signatures (JWS)
  - Create, modify, parse, validate or serialize JSON Web Encryption (JWE)
    limited and experimental!
  - Create, modify, parse, validate or serialize JSON Web Token (JWT)
 .
 JWT Relies on JWS and JWE functions, so it supports the same functionnalities
 as the other 2. JWT functionnalities also support nesting serilization
 (JWE nested in a JWS or the opposite).
 .
 This package contains the development files.

Package: rnbyc
Architecture: any
Depends: ${shlibs:Depends},
       , librhonabwy0.9 (= ${binary:Version})
       , ${misc:Depends}
Description: JWK and JWT parser and generator
 Rhonabwy JWK and JWT parser and generator
 .
  - Generate and/or parse keys and output the result in a JWKS or a
    public/private pair of JWKS files.
  - Parse, decrypt, and/or verify signature of a JWT, using given key
  - Serialize a JWT, the JWT can be signed, encrypted or nested
