=== debian/tests/control ===
Tests: unit-test
Depends: @, libgnutls28-dev, zlib1g-dev, libulfius-dev, gcc, libc-dev, liborcania-dev, libyder-dev, check, libsubunit-dev, pkg-config
