## rhonabwy 0.9.13

=== CMakeLists.txt ===
--- 
+++ 
@@ -30,10 +30,10 @@
 set(PROJECT_BUGREPORT_PATH "https://github.com/babelouest/rhonabwy/issues")
 set(LIBRARY_VERSION_MAJOR "0")
 set(LIBRARY_VERSION_MINOR "9")
-set(LIBRARY_VERSION_PATCH "12")
+set(LIBRARY_VERSION_PATCH "13")
 set(ORCANIA_VERSION_REQUIRED "2.1.1")
-set(YDER_VERSION_REQUIRED "1.4.11")
-set(ULFIUS_VERSION_REQUIRED "2.6.8")
+set(YDER_VERSION_REQUIRED "1.4.12")
+set(ULFIUS_VERSION_REQUIRED "2.7.0")
 
 set(PROJECT_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
 set(PROJECT_VERSION_MAJOR ${LIBRARY_VERSION_MAJOR})
