=== src/Makefile ===
--- 
+++ 
@@ -37,7 +37,7 @@
 OUTPUT=librhonabwy.so
 VERSION_MAJOR=0
 VERSION_MINOR=9
-VERSION_PATCH=12
+VERSION_PATCH=13
 
 .PHONY: all clean
