=== debian/changelog ===
rhonabwy (0.9.13-4) unstable; urgency=medium

  * d/rules: remove dpkg-shlibdeps from override_dh_auto_install
  * d/patches/bugfixes: apply upstream bugfixes (Closes: #993866)

 -- Nicolas Mora <babelouest@debian.org>  Tue, 07 Sep 2021 11:42:23 -0400

rhonabwy (0.9.13-3) unstable; urgency=medium

  * Fix r_library_info_json_t output

 -- Nicolas Mora <babelouest@debian.org>  Tue, 09 Feb 2021 07:33:21 -0500

rhonabwy (0.9.13-2) unstable; urgency=medium

  * d/control: Add jansson in builddep and librhonabwy-dev dep

 -- Nicolas Mora <babelouest@debian.org>  Wed, 06 Jan 2021 07:35:56 -0500

rhonabwy (0.9.13-1) unstable; urgency=medium

  * New upstream release
  * d/control: Remove dh-exec from builddep
  * d/rules: update override_dh_auto_test to generate certificates
  * d/control: Add builddep gnutls-bin to generate certificates
  * d/symbols: Update symbols table
  * d/control: Update standards version to 4.5.1 (no change)
  * d/tests: add gnutls-bin to generate certificates for tests
  * d/control: add librhonabwy-dev dependendies

 -- Nicolas Mora <babelouest@debian.org>  Wed, 16 Dec 2020 08:49:38 -0500
