=== debian/rules ===
--- 
+++ 
@@ -23,6 +23,7 @@
 
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 override_dh_auto_test:
+	cd test && ./cert/create-cert.sh && cp -R cert/ ../build/
 	dh_auto_test
 endif
